<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/24/2009 *
 * ===================                          Last change: 10/24/2009 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : load-imprint.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Load more cache files                            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mehr Cache-Dateien nachladen                     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} elseif (isInstallationPhase()) {
	// Use this code if you don't want to run this cache loader on installation phase
	return;
} elseif (!isExtensionInstalled('imprint')) {
	// Not not cache if not installed!
	return;
}

// Let's start with the admins table...
if (($GLOBALS['cache_instance']->loadCacheFile('imprint')) && ($GLOBALS['cache_instance']->extensionVersionMatches('imprint'))) {
	// Load cache
	$GLOBALS['cache_array']['imprint'] = $GLOBALS['cache_instance']->getArrayFromCache();
} elseif (isHtmlOutputMode()) {
	// Create cache file
	$GLOBALS['cache_instance']->init();

	// Load every data from DB to cache file
	$add = runFilterChain('sql_admin_extra_data');

	// Query the database about this
	$result = SQL_QUERY('SELECT * FROM `{?_MYSQL_PREFIX?}_imprint_data` ORDER BY `imprint_id` ASC', __FILE__, __LINE__);
	while ($row = SQL_FETCHARRAY($result)) {
		// Save row
		$GLOBALS['cache_instance']->addRow($row);
	} // END - while

	// Free memory
	SQL_FREERESULT($result);

	// Close cache
	$GLOBALS['cache_instance']->storeExtensionVersion('imprint');
	$GLOBALS['cache_instance']->finalize();
}

// [EOF]
?>
