<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/15/2008 *
 * ===================                          Last change: 09/15/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : load-themes.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Load more cache files                            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mehr Cache-Dateien nachladen                     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} elseif (isInstallationPhase()) {
	// Use this code if you don't want to run this cache loader on installation phase
	return;
} elseif (!isExtensionActive('theme')) {
	// Skip this loader
	return false;
}

// Next cached table is the referal system (themes)...
if (($GLOBALS['cache_instance']->loadCacheFile('themes')) && ($GLOBALS['cache_instance']->extensionVersionMatches('theme'))) {
	// Load referal system from cache
	$cache = $GLOBALS['cache_instance']->getArrayFromCache();

	// Restructure the array
	$GLOBALS['cache_array']['themes'] = array();
	foreach ($cache as $key => $content) {
		// Skip 'theme_path' because we don't need to rebuild it
		if ($key == 'theme_path') {
			// Add entries with id
			foreach ($content as $id => $entry) {
				$GLOBALS['cache_array']['themes']['theme_path'][$cache['id'][$id]] = $entry;
			} // END - foreach
		} else {
			// Add all themes with theme name as array index
			foreach ($content as $id => $entry) {
				$GLOBALS['cache_array']['themes'][$key][$cache['theme_path'][$id]] = $entry;
			} // END - foreach
		}
	} // END - foreach

	// Remove dummy array
	unset($cache);
} elseif (isHtmlOutputMode()) {
	// Create cache file here
	$GLOBALS['cache_instance']->init();

	// Load all themes and their data
	if (isExtensionInstalledAndNewer('theme', '0.0.7')) {
		$result = SQL_QUERY('SELECT `id`,`theme_path`,`theme_active`,`theme_ver`,`theme_name` FROM `{?_MYSQL_PREFIX?}_themes` ORDER BY `id` ASC', __FILE__, __LINE__);
	} else {
		$result = SQL_QUERY('SELECT `id`,`theme_path`,`theme_active`,`theme_ver` FROM `{?_MYSQL_PREFIX?}_themes` ORDER BY `id` ASC', __FILE__, __LINE__);
	}
	while ($content = SQL_FETCHARRAY($result)) {
		// Add row to cache file
		$GLOBALS['cache_instance']->addRow($content);
	} // END - while

	// Free memory
	SQL_FREERESULT($result);

	// Close the cache
	$GLOBALS['cache_instance']->storeExtensionVersion('theme');
	$GLOBALS['cache_instance']->finalize();
}

// [EOF]
?>
